#include "twi.h"           // заголовочный библиотеки TWI


void I2C_Init(void)			// Настройка режима мастера
{
i2c_PORT |= 1<<i2c_SCL|1<<i2c_SDA;	// Включим подтяжку на ноги, вдруг юзер на резисторы пожмотился
i2c_DDR &=~(1<<i2c_SCL|1<<i2c_SDA);
 
TWBR = 0x0C;         			// Настроим битрейт TWBR=(((F_CPU/F_SCL)-16)/(2*4^TWPS)); 
TWSR = 0x00;                    
}


// Старт!
void I2C_Start(void)
{
  TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
  while(!(TWCR&(1<<TWINT)));//подождем пока установится TWIN
}


// Стоп!
void I2C_Stop(void)
{
  TWCR = (1<<TWINT)|(1<<TWSTO)|(1<<TWEN);
}

// Отправка байта
// Если ок, то функция вернет 1
int I2C_SendByte(unsigned char c)
{
  TWDR = c;//запишем байт в регистр данных
  TWCR = (1<<TWINT)|(1<<TWEN);//включим передачу байта
  while (!(TWCR & (1<<TWINT)));//подождем пока установится TWIN
  if ((TWSR & 0xF8) == WRITE_ASK) // Отсекаем биты прескалера и сравниваем
  {
    return 1;
  }
  return 0;
}